
import java.io.* ;
import hpjava.* ;

public class MandelWorker extends Child {
  static int N, RESOLUTION ;

  public static void main(String args[]) {
    try {
      // Get parameters from host

      N                = initial.recvInt() ;
      int ARRAYSIZE    = initial.recvInt() ;
      int BLOCKSIZEMAX = initial.recvInt() ;

      RESOLUTION       = initial.recvInt() ;

      // Create port stream

      DataOutputStream toHost =
          new DataOutputStream(new PortOutputStream(initial)) ;

      int [] block = new int [BLOCKSIZEMAX] ;

      int blockBase = 0 ;
      int blockSize = 0 ;

      for( ; ; ) {
	//  Send request for new task (and old result data) to host.

	toHost.writeInt(blockBase) ;
	toHost.writeInt(blockSize) ;
	for(int i = 0 ; i < blockSize ; i++)
	  toHost.writeInt(block [i]) ;
	toHost.flush() ;

	//  Receive a new task (new `blockBase') from the host.

	blockBase = initial.recvInt() ;
	if(blockBase >= ARRAYSIZE) break ;  //  This node finishes processing.

	//  Perform task.

	if(blockBase + BLOCKSIZEMAX > ARRAYSIZE)
	  blockSize = ARRAYSIZE - blockBase ;
	else
	  blockSize = BLOCKSIZEMAX ;

	for(int i = 0 ; i < blockSize ; i++) {
	  int j = blockBase + i ;

	  block [i] = do_mandel(j / N, j % N) ;
	}
      }
    }
    catch(Exception e) {
      e.printStackTrace() ;
    }
  }

  static int do_mandel(int x, int y) {
    int colour ;

    float cr = (float) (4 * x - 2 * N) / (float) (N - 1) ;
    float ci = (float) (4 * y - 2 * N) / (float) (N - 1) ;

    float zr = cr ;
    float zi = ci ;

    float zrs = zr * zr ;
    float zis = zi * zi ;

    for(colour = 0 ; (zrs + zis) < 4.0 && colour < RESOLUTION ; colour++) {

      zrs = zr * zr ;
      zis = zi * zi ;

      //zi = 2.0 * zr * zi + ci ;
      zi = 2 * zr * zi + ci ;
      zr = zrs - zis     + cr ;
    }

    return colour ;
  }
}

